package org.beangle.commons.comparator;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

/**
 * 组合比较器
 * 
 * @author chaostone
 * 
 */
public class ChainComparator implements Comparator {

	private List<Comparator> comparators;

	public int compare(final Object first, final Object second) {
		int cmpRs = 0;
		for (final Comparator com : comparators) {
			cmpRs = com.compare(first, second);
			if (0 == cmpRs) {
				continue;
			} else {
				break;
			}
		}
		return cmpRs;
	}

	public ChainComparator() {
		this.comparators = new ArrayList();
	}

	public ChainComparator(final List comparators) {
		super();
		this.comparators = comparators;
	}

	public void addComparator(final Comparator com) {
		this.comparators.add(com);
	}

	public List<Comparator> getComparators() {
		return comparators;
	}

	public void setComparators(final List<Comparator> comparators) {
		this.comparators = comparators;
	}

}
