/*
 *
 * Copyright c 2005-2009.
 * 
 * Licensed under GNU  LESSER General Public License, Version 3.
 * http://www.gnu.org/licenses
 * 
 */
/********************************************************************************
 * @author chaostone
 * 
 * MODIFICATION DESCRIPTION
 * 
 * Name                 Date                Description 
 * ============         ============        ============
 * chaostone             2008-2-7            Created
 *  
 ********************************************************************************/
package org.beangle.config;

import java.util.ArrayList;
import java.util.List;

import org.beangle.config.loader.SystemConfigLoader;
import org.beangle.config.model.DefaultSystemConfig;

/**
 * 系统配置加载器
 * 
 * @author chaostone
 * 
 */
public class SystemConfigFactory {

	private List<SystemConfigLoader> loaders = new ArrayList();

	private SystemConfig config;

	public SystemConfig getConfig() {
		if (null == config) {
			reload();
		}
		return config;
	}

	// TODO syn
	public void reload() {
		config = new DefaultSystemConfig();
		for (SystemConfigLoader loader : loaders) {
			loader.load(config);
		}
	}

	public List<SystemConfigLoader> getLoaders() {
		return loaders;
	}

	public void setLoaders(List<SystemConfigLoader> loaders) {
		this.loaders = loaders;
	}

}
