package org.beangle.config.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;

/**
 * 系统配置
 * 
 * @author chaostone
 * 
 */
public class DefaultSystemConfig implements org.beangle.config.SystemConfig {

	private String systemName;

	private String vendor;

	private Map items = new HashMap();

	public Object getConfigItemValue(String name) {
		return (Object) items.get(name);
	}

	public void setConfigItemValue(String name, Object value) {
		items.put(name, value);
	}

	public int getIntParam(String name) {
		return NumberUtils.toInt((String) getConfigItemValue(name));
	}

	public boolean getBoolParam(String name) {
		return new Boolean((String) getConfigItemValue(name)).booleanValue();
	}

	public String getSystemName() {
		return systemName;
	}

	public void setSystemName(String systemName) {
		this.systemName = systemName;
	}

	public String getVendor() {
		return vendor;
	}

	public void setVendor(String vendor) {
		this.vendor = vendor;
	}

	public Map getItems() {
		return items;
	}

	public void setItems(Map params) {
		this.items = params;
	}

	public String getUrl() {
		return (String) getConfigItemValue("system.config.url");
	}

	public String getDevelopers() {
		return (String) getConfigItemValue("system.config.developers");
	}

	public String toString() {
		StringBuilder sb = new StringBuilder("DefaultSystemConfig[");
		sb.append("\nsystemName =").append(getSystemName());
		sb.append("\nvendor     =").append(getVendor());
		List<String> props = new ArrayList(items.keySet());
		Collections.sort(props);
		int maxlength = 0;
		for (String property : props) {
			if (property.length() > maxlength) {
				maxlength = property.length();
			}
		}
		for (String property : props) {
			sb.append('\n').append(property);
			sb.append(StringUtils.repeat(" ", maxlength - property.length()));
			sb.append('=').append(items.get(property));
		}
		sb.append("\n]");
		return sb.toString();
	}
}
